gtksourceviewmm 3.18.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gsv::Completion Class Reference

Main Completion Object. More...

`#include <gtksourceviewmm/completion.h>`

Inherits Glib::Object.

## Public Member Functions
| Completion (Completion&& src) noexcept
Completion& | operator= (Completion&& src) noexcept
| ~Completion () noexcept override
GtkSourceCompletion* | gobj ()
| Provides access to the underlying C GObject.
const GtkSourceCompletion* | gobj () const
| Provides access to the underlying C GObject.
GtkSourceCompletion* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
bool | add_provider (const Glib::RefPtr< CompletionProvider >& provider)
| Add a new CompletionProvider to the completion object.
bool | remove_provider (const Glib::RefPtr< CompletionProvider >& provider)
| Remove provider from the completion.
std::vector< Glib::RefPtr< CompletionProvider > > | get_providers () const
| Get list of providers registered on completion.
bool | show (const std::vector< Glib::RefPtr< CompletionProvider > >& providers, const Glib::RefPtr< CompletionContext >& context)
| Starts a new completion with the specified CompletionContext and a list of potential candidate providers for completion.
void | hide ()
| Hides the completion if it is active (visible).
CompletionInfo* | get_info_window ()
| Gets the CompletionInfo window.
const CompletionInfo* | get_info_window () const
| Gets the CompletionInfo window.
View* | get_view ()
| Gets the View associated with completion.
const View* | get_view () const
| Gets the View associated with completion.
Glib::RefPtr< CompletionContext > | create_context (const Gtk::TextIter& position)
| Create a new CompletionContext for completion.
Glib::RefPtr< CompletionContext > | create_context ()
| Create a new CompletionContext for completion.
void | move_window (const Gtk::TextIter& iter)
| Move the completion window to a specific iter.
void | block_interactive ()
| Block interactive completion.
void | unblock_interactive ()
| Unblock interactive completion.
Glib::SignalProxy< void > | signal_hide ()
| Emitted when the completion window is hidden.
Glib::SignalProxy< void, const Glib::RefPtr< CompletionContext >& > | signal_populate_context ()
| Emitted just before starting to populate the completion with providers.
Glib::SignalProxy< void > | signal_show ()
| Emitted when the completion window is shown.
Glib::PropertyProxy< guint > | property_accelerators ()
| Number of proposal accelerators to show.
Glib::PropertyProxy_ReadOnly< guint > | property_accelerators () const
| Number of proposal accelerators to show.
Glib::PropertyProxy< guint > | property_auto_complete_delay ()
| Completion popup delay for interactive completion.
Glib::PropertyProxy_ReadOnly< guint > | property_auto_complete_delay () const
| Completion popup delay for interactive completion.
Glib::PropertyProxy< guint > | property_proposal_page_size ()
| Proposal scrolling page size.
Glib::PropertyProxy_ReadOnly< guint > | property_proposal_page_size () const
| Proposal scrolling page size.
Glib::PropertyProxy< guint > | property_provider_page_size ()
| Provider scrolling page size.
Glib::PropertyProxy_ReadOnly< guint > | property_provider_page_size () const
| Provider scrolling page size.
Glib::PropertyProxy< bool > | property_remember_info_visibility ()
| Remember the last info window visibility state.
Glib::PropertyProxy_ReadOnly< bool > | property_remember_info_visibility () const
| Remember the last info window visibility state.
Glib::PropertyProxy< bool > | property_select_on_show ()
| Select first proposal when completion is shown.
Glib::PropertyProxy_ReadOnly< bool > | property_select_on_show () const
| Select first proposal when completion is shown.
Glib::PropertyProxy< bool > | property_show_headers ()
| Show provider headers when proposals from multiple providers are available.
Glib::PropertyProxy_ReadOnly< bool > | property_show_headers () const
| Show provider headers when proposals from multiple providers are available.
Glib::PropertyProxy< bool > | property_show_icons ()
| Show provider and proposal icons in the completion popup.
Glib::PropertyProxy_ReadOnly< bool > | property_show_icons () const
| Show provider and proposal icons in the completion popup.
Glib::PropertyProxy_ReadOnly< View* > | property_view () const
| The GtkSourceView bound to the completion.

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
virtual void | on_hide ()
| This is a default handler for the signal signal_hide().
virtual void | on_populate_context (const Glib::RefPtr< CompletionContext >& context)
| This is a default handler for the signal signal_populate_context().
virtual void | on_show ()
| This is a default handler for the signal signal_show().

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gsv::Completion > | wrap (GtkSourceCompletion* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Main Completion Object.

Since gtksourceviewmm 2.10

## Constructor & Destructor Documentation

## ◆ Completion()

Gsv::Completion::Completion | ( | Completion&& | src | ) |
| noexcept

## ◆ ~Completion()

Gsv::Completion::~Completion | ( |  | ) |
| override noexcept

## Member Function Documentation

## ◆ add_provider()

bool Gsv::Completion::add_provider | ( | const Glib::RefPtr< CompletionProvider >& | provider | ) |

Add a new CompletionProvider to the completion object.

This will add a reference provider.

Parameters

  provider | A CompletionProvider.

Returns
  `true` if provider was successfully added, otherwise error is thrown.

Since gtksourceviewmm 2.10

## ◆ block_interactive()

void Gsv::Completion::block_interactive | ( |  | ) |

Block interactive completion.

This can be used to disable interactive completion when inserting or deleting text from the buffer associated with the completion. Use unblock_interactive() to enable interactive completion again.

Since gtksourceviewmm 2.10

## ◆ create_context() [1/2]

Glib::RefPtr< CompletionContext > Gsv::Completion::create_context | ( |  | ) |

Create a new CompletionContext for completion.

The position at which the completion using the new context will consider completion is current cursor position.

Returns
  A new CompletionContext.

Since gtksourceviewmm 2.10

## ◆ create_context() [2/2]

Glib::RefPtr< CompletionContext > Gsv::Completion::create_context | ( | const Gtk::TextIter & | position | ) |

Create a new CompletionContext for completion.

The position at which the completion using the new context will consider completion can be provided by position.

Parameters

  position | A Gtk::TextIter.

Returns
  A new CompletionContext.

Since gtksourceviewmm 2.10

## ◆ get_info_window() [1/2]

CompletionInfo* Gsv::Completion::get_info_window | ( |  | ) |

Gets the CompletionInfo window.

The info widget is the window where the completion displays optional extra information of the proposal.

Returns
  The CompletionInfo window.

Since gtksourceviewmm 2.10

## ◆ get_info_window() [2/2]

const CompletionInfo* Gsv::Completion::get_info_window | ( |  | ) | const

Gets the CompletionInfo window.

The info widget is the window where the completion displays optional extra information of the proposal.

Returns
  The CompletionInfo window.

Since gtksourceviewmm 2.10

## ◆ get_providers()

std::vector< Glib::RefPtr< CompletionProvider > > Gsv::Completion::get_providers | ( |  | ) | const

Get list of providers registered on completion.

Returns
  List of CompletionProvider.

Since gtksourceviewmm 2.10

## ◆ get_type()

static GType Gsv::Completion::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_view() [1/2]

View* Gsv::Completion::get_view | ( |  | ) |

Gets the View associated with completion.

Returns
  The View associated with completion.

Since gtksourceviewmm 2.10

## ◆ get_view() [2/2]

const View* Gsv::Completion::get_view | ( |  | ) | const

Gets the View associated with completion.

Returns
  The View associated with completion.

Since gtksourceviewmm 2.10

## ◆ gobj() [1/2]

GtkSourceCompletion * Gsv::Completion::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkSourceCompletion * Gsv::Completion::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkSourceCompletion * Gsv::Completion::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ hide()

void Gsv::Completion::hide | ( |  | ) |

Hides the completion if it is active (visible).

Since gtksourceviewmm 2.10

## ◆ move_window()

void Gsv::Completion::move_window | ( | const Gtk::TextIter & | iter | ) |

Move the completion window to a specific iter.

Parameters

  iter | A Gtk::TextIter.

Since gtksourceviewmm 2.10

## ◆ on_hide()

virtual void Gsv::Completion::on_hide | ( |  | ) |
| protected virtual

This is a default handler for the signal signal_hide().

## ◆ on_populate_context()

virtual void Gsv::Completion::on_populate_context | ( | const Glib::RefPtr< CompletionContext >& | context | ) |
| protected virtual

This is a default handler for the signal signal_populate_context().

## ◆ on_show()

virtual void Gsv::Completion::on_show | ( |  | ) |
| protected virtual

This is a default handler for the signal signal_show().

## ◆ operator=()

Completion& Gsv::Completion::operator= | ( | Completion&& | src | ) |
| noexcept

## ◆ property_accelerators() [1/2]

Glib::PropertyProxy< guint > Gsv::Completion::property_accelerators | ( |  | ) |

Number of proposal accelerators to show.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_accelerators() [2/2]

Glib::PropertyProxy_ReadOnly< guint > Gsv::Completion::property_accelerators | ( |  | ) | const

Number of proposal accelerators to show.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_auto_complete_delay() [1/2]

Glib::PropertyProxy< guint > Gsv::Completion::property_auto_complete_delay | ( |  | ) |

Completion popup delay for interactive completion.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_auto_complete_delay() [2/2]

Glib::PropertyProxy_ReadOnly< guint > Gsv::Completion::property_auto_complete_delay | ( |  | ) | const

Completion popup delay for interactive completion.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_proposal_page_size() [1/2]

Glib::PropertyProxy< guint > Gsv::Completion::property_proposal_page_size | ( |  | ) |

Proposal scrolling page size.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_proposal_page_size() [2/2]

Glib::PropertyProxy_ReadOnly< guint > Gsv::Completion::property_proposal_page_size | ( |  | ) | const

Proposal scrolling page size.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_provider_page_size() [1/2]

Glib::PropertyProxy< guint > Gsv::Completion::property_provider_page_size | ( |  | ) |

Provider scrolling page size.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_provider_page_size() [2/2]

Glib::PropertyProxy_ReadOnly< guint > Gsv::Completion::property_provider_page_size | ( |  | ) | const

Provider scrolling page size.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_remember_info_visibility() [1/2]

Glib::PropertyProxy< bool > Gsv::Completion::property_remember_info_visibility | ( |  | ) |

Remember the last info window visibility state.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_remember_info_visibility() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gsv::Completion::property_remember_info_visibility | ( |  | ) | const

Remember the last info window visibility state.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_select_on_show() [1/2]

Glib::PropertyProxy< bool > Gsv::Completion::property_select_on_show | ( |  | ) |

Select first proposal when completion is shown.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_select_on_show() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gsv::Completion::property_select_on_show | ( |  | ) | const

Select first proposal when completion is shown.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_show_headers() [1/2]

Glib::PropertyProxy< bool > Gsv::Completion::property_show_headers | ( |  | ) |

Show provider headers when proposals from multiple providers are available.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_show_headers() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gsv::Completion::property_show_headers | ( |  | ) | const

Show provider headers when proposals from multiple providers are available.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_show_icons() [1/2]

Glib::PropertyProxy< bool > Gsv::Completion::property_show_icons | ( |  | ) |

Show provider and proposal icons in the completion popup.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_show_icons() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gsv::Completion::property_show_icons | ( |  | ) | const

Show provider and proposal icons in the completion popup.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_view()

Glib::PropertyProxy_ReadOnly< View* > Gsv::Completion::property_view | ( |  | ) | const

The GtkSourceView bound to the completion.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ remove_provider()

bool Gsv::Completion::remove_provider | ( | const Glib::RefPtr< CompletionProvider >& | provider | ) |

Remove provider from the completion.

Parameters

  provider | A CompletionProvider.

Returns
  `true` if provider was successfully removed, otherwise error is thrown.

Since gtksourceviewmm 2.10

## ◆ show()

bool Gsv::Completion::show | ( | const std::vector< Glib::RefPtr< CompletionProvider > >& | providers,
|  | const Glib::RefPtr< CompletionContext >& | context )

Starts a new completion with the specified CompletionContext and a list of potential candidate providers for completion.

Parameters

  providers | A list of CompletionProvider.
  context | The CompletionContext with which to start the completion.

Returns
  `true` if it was possible to the show completion window.

Since gtksourceviewmm 2.10

## ◆ signal_hide()

Glib::SignalProxy< void > Gsv::Completion::signal_hide | ( |  | ) |

Emitted when the completion window is hidden.

The default handler will actually hide the window.

Since gtksourceviewmm 2.10

Slot Prototype:
  `void on_my_hide()`

Flags: Run Last

## ◆ signal_populate_context()

Glib::SignalProxy< void, const Glib::RefPtr< CompletionContext >& > Gsv::Completion::signal_populate_context | ( |  | ) |

Emitted just before starting to populate the completion with providers.

You can use this signal to add additional attributes in the context.

Handler parameters:
  context The context for current completion.

Since gtksourceviewmm 2.10

Slot Prototype:
  `void on_my_populate_context(const Glib::RefPtr<CompletionContext>& context)`

Flags: Run Last

## ◆ signal_show()

Glib::SignalProxy< void > Gsv::Completion::signal_show | ( |  | ) |

Emitted when the completion window is shown.

The default handler will actually show the window.

Since gtksourceviewmm 2.10

Slot Prototype:
  `void on_my_show()`

Flags: Run Last

## ◆ unblock_interactive()

void Gsv::Completion::unblock_interactive | ( |  | ) |

Unblock interactive completion.

This can be used after using block_interactive() to enable interactive completion again.

Since gtksourceviewmm 2.10

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gsv::Completion > wrap | ( | GtkSourceCompletion * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.